// btn-xs
// @source https://stackoverflow.com/a/50931961
.btn-group-xs > .btn, .btn-xs {
  padding: .25rem .4rem;
  font-size: .75rem;
  line-height: .5;
  border-radius: .2rem;
}

// @source https://css-tricks.com/flexbox-truncated-text/
.flex-child {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}

// div nowrap
// .   {
//   display: inline-flex;
// }

// fix sub tabs icons colors
.nav-tabs-project .btn-primary .icon {
    color: #fff;
}

// table min height
.table-projects-outputs-history {
  overflow-x: hidden;
}

// table th,td min width
// @source https://stackoverflow.com/a/31184284
.table td.fit,
.table th.fit {
    white-space: nowrap;
    width: 1%;
}

// hr-text xs
.hr-text-xs {
  font-size: 0.5rem;
}

// reduce font size
.textarea-project-description {
  font-size: 0.7rem;
  resize: none;
  overflow: hidden;
}

// skeleton texts
.skeleton-text {
  padding: .375rem 0;
  display: block;
  line-height: 0;
  //height: $font-size-base * $line-height-base;

  @each $name, $size in $skeleton-text-sizes {
    &-#{$name} {
      height: $size * $phi;
      @for $i from 2 through 12 {
        &-phi-#{$i} {
          width: $size * $i * $phi;
        }
      }
    }
  }

  &:after {
    content: '';
    display: inline-block;
    height: 100%;
    border-radius: $border-radius;
    width: 100%;
    @extend %skeleton-common;
  }
}

// skeleton buttons
.skeleton-button {
  @extend %skeleton-common;
  display: inline-block;
  vertical-align: middle;
  border-radius: 0.2rem;
  &:after {
    content: '';
    padding-top: percentage(9/16);
    display: block;
  }
  @each $name, $size in $skeleton-buttons-sizes {
    &-#{$name} {
      width: $size * $phi;
      height: $size;
      @for $i from 2 through 12 { 
        &-phi-#{$i} {
          width: $size * $i * $phi;
        }
      }
    }
  }
}

// skeleton avatar list
.skeleton-avatar-list {
  display: inline-flex;
  padding: 0;
  margin: -2px 0 -.5rem;

  .skeleton-avatar {
    margin-bottom: .5rem;

    &:not(:last-child) {
      margin-right: .5rem;
    }
  }
}

// skeleton avatar list stacked
.skeleton-avatar-list-stacked {
  .skeleton-avatar {
    margin-right: -.5rem !important;
    box-shadow: 0 0 0 2px $white;

    @at-root .card-footer & {
      box-shadow: 0 0 0 2px $card-cap-bg;
    }
  }
}

// this is being used to hide/show project header actions
.nav-toggle {
  .nav-toggle-item {
    display: none !important;

    &.active {
      display: flex !important;
    }
  }
}

// this is being used to hide/show scenario config cards
.card-sce-params-deck {
  .card-sce-params {
    display: none !important;

    &.active {
      display: flex !important;
    }
  }
}

// No project activity blank
.no-project-activity {
  padding: 1rem 4rem 1rem 4rem;
}

.no-project-outputs {
  padding: 12rem 4rem 12rem 4rem;
}

// empty imagen large
.empty-img-lg {
  margin: 0 0 2rem;
  line-height: 1;

  img {
    height: 12rem;
    width: auto;
  }
}

// empty imagen small
.empty-img-sm {
  margin: 2rem 0 1rem;
  line-height: 1;

  img {
    height: 5rem;
    width: auto;
  }
}

//
.col-sce-param-value input.sce-param-value-type-string::placeholder {
  color: #919191 !important;
  font-size: .8rem;
}

// this is being used to highlighting tables rows e.g for
// parms editor and output lists 
.hover-table:hover > tr {
  opacity: 0.7;
  background-color: $table-color;
}

.hover-table > tr > td > div > .btn-group-actions {
  opacity: 0;
}

.hover-table > tr > td > div > .btn-group-actions:focus,
.hover-table > tr > td > div > .btn-group-actions:active {
   outline: none !important;
   box-shadow: none;
}

.hover-table:hover > tr:hover {
  opacity: 1.0;
  background-color: $active-bg;
}

.hover-table:hover > tr:hover > td > span.text-muted {
  color: inherit !important;
}

.hover-table:hover > tr:hover > td > div > .btn-group-actions {
  opacity: 1.0;
}

// advanced mode param class
.mode-advanced-param {
  font-style: italic !important;
}

// text clamps
@for $i from 1 through 6 {
  .text-clamp-#{$i} {
    @include text-clamp($i, ($font-size-base * $line-height-base * 1.1));
  }
}

// text justify
.text-justify  {
  text-align: justify !important;
}

// min width 0
.mw-0  {
  min-width: 0px !important;
}

// used on full size cards to fix version dropdown position
.mt-11-5 {
 margin-top: 11.5rem !important;
}

// use $zindex-popover variable from boostrap
.zindex-popover {
  z-index: $zindex-popover;
}

// z-index-1
.z-index-1 {
  z-index: 1;
}

// Fix Bootstrap menu-item stays selected and is only
// clickable one time
// @see https://stackoverflow.com/a/52117265
.dropdown-tab .dropdown-menu {
  display : none !important;
}

// Fix avatar-list-stacked not centered
.avatar-list-stacked {
  margin-left: -.5rem !important;
}

// Fix text-muted dark
.navbar-dark {
  .text-muted {
    color: rgba($dark, $text-muted-dark-opacity) !important;
  }
}

// Small list-timeline-icon
.list-timeline-icon-xs {
  width: 1rem;
  height: 1rem;
  .icon {
    width: 0.7rem;
    height: 0.7rem;
    font-size: 0.7rem;
  }
}

// Small list-timeline-content
.list-timeline-content-xs {
  margin-left: 1.5rem;
}

// Extend min-width for notifications cards
.dropdown-menu-notifications {
  min-width: $phi-0 * $dropdown-max-width;
}

// upload modal height
#modal-upload-dataset .modal-dialog .modal-content .card {
  height: $phi-0 * $modal-lg;
}

// navitems rimow colors
@each $name, $color in $rimow-meta-colors {
  .nav-item.active-#{$name} {
    &:after {
      border-color: #{$color} !important;
    }
  }
}

// to disallow pointer-events on disabled selectize buttons
.btn-add-selectize, .btn-main-scenario-configure {
  pointer-events: auto;
  &:disabled,
  &.disabled {
    cursor: wait;
    pointer-events: none;
  }
}

// tab pane projects animated loading
.tab-pane-board-projects, .tab-pane-config-scenario {
  position: relative;
  -webkit-transition: opacity 1.2s ease;
  -moz-transition: opacity 1.2s ease;
  -ms-transition: opacity 1.2s ease;
  -o-transition: opacity 1.2s ease;
  transition:  opacity 1.2s ease-out;

  &.loading {
    &::after {
      content: "";
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
      background-image: url('~@/assets/img/loading.svg');
      background-repeat: no-repeat;
      background-size: 30%;
      background-position: 50% 50%;
      z-index: 2;
    }
    &::before {
      content: "";
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
      background: rgba(245, 247, 251, 0.8);
      backdrop-filter: blur(8px);
      z-index: 1;
    }
  }
}

tr.active {
  background-color: $active-bg;
}

// this is being used to highlight markdown documentation
.markdown {
  h1, h2, h3, h4, h5, h6 {
      &.active {
        background-color: $active-bg;
      }
  }
}

.dropdown-tab .dropdown-menu.show {
  display : block !important;
}

.card-sponsor {
  background: #dbe7f6 no-repeat center/100% 100%;
  border-color: #548ed2;
  min-height: 316px;
}

body.no-transitions * {
  transition: none !important;
}


.dropdown-menu-demo {
  display: inline-block;
  width: 100%;
  position: relative;
  top: 0;
  margin-bottom: 1rem;
}

.demo-icon-preview {
  position: sticky;
  top: 0;

  svg,
  i {
    width: 15rem;
    height: 15rem;
    font-size: 15rem;
    stroke-width: 1.5;
    margin: 0 auto;
    display: block;

    @include media-breakpoint-down(sm) {
      width: 10rem;
      height: 10rem;
      font-size: 10rem;
    }
  }
}

.demo-icon-preview-icon {
  pre {
    margin: 0;
    user-select: all;
  }
}

.demo-dividers {
  >p {
    opacity: .2;
    user-select: none;
  }
}


$demo-icon-size: 7rem;
.demo-icons-list {
  display: flex;
  flex-wrap: wrap;
  padding: 0;
  margin: 0 -2px -1px 0;
  list-style: none;

  >* {
    flex: 1 0 $demo-icon-size;
  }
}

.demo-icons-list-wrap {
  overflow: hidden;
}

.demo-icons-list-item {
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
  height: $demo-icon-size;
  text-align: center;
  padding: .5rem;
  border-right: 1px solid $border-color;
  border-bottom: 1px solid $border-color;
  color: inherit;
  cursor: pointer;

  .icon {
    width: 1.5rem;
    height: 1.5rem;
    font-size: 1.5rem;
  }

  &:hover {
    text-decoration: none;
  }
}

.cursor-default {
  cursor: default !important;
}

.cursor-pointer {
  cursor: pointer !important;
}

.disabled-action {
  pointer-events: none;
}

.cursor-not-allowed {
  cursor: not-allowed;
}

.justify-content-start {
  justify-content: flex-start;
}